/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         amd_parse
#define yylex           amd_lex
#define yyerror         amd_error
#define yydebug         amd_debug
#define yynerrs         amd_nerrs
#define yylval          amd_lval
#define yychar          amd_char

/* First part of user prologue.  */
#line 1 "amd_parse.y"

/* ----------------------------------------------------------------------- *
 *
 *  Copyright 2013 Ian Kent <raven@themaw.net>
 *  Copyright 2013 Red Hat, Inc.
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
 *  USA; either version 2 of the License, or (at your option) any later
 *  version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * ----------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/ioctl.h>
#include <syslog.h>

#include "automount.h"
#include "parse_amd.h"
#include "log.h"

#define MAX_OPTS_LEN	1024
#define MAX_ERR_LEN	3096

static pthread_mutex_t parse_mutex = PTHREAD_MUTEX_INITIALIZER;

extern FILE *amd_in;
extern char *amd_text;
extern int amd_lex(void);
extern void amd_set_scan_buffer(const char *);

static char *amd_strdup(char *);
static void amd_set_value(char **, char *);
static void local_init_vars(void);
static void local_free_vars(void);

static int amd_error(const char *s);
static int amd_notify(const char *s);
static int amd_info(const char *s);
static int amd_msg(const char *s);

static int add_location(void);
static int make_selector(char *name,
			 char *value1, char *value2,
			 unsigned int compare);
static void add_selector(struct selector *selector);

static int match_map_option_fs_type(char *map_option, char *type);
static int match_map_option_map_type(char *map_option, char *type);
static int match_map_option_cache_option(char *type);
static int match_mnt_option_options(char *mnt_option, char *options);

static struct amd_entry entry;
static struct list_head *entries;
static struct autofs_point *pap;
struct substvar *psv;
static char opts[MAX_OPTS_LEN];
static void prepend_opt(char *, char *);
static char msg_buf[MAX_ERR_LEN];

#define YYDEBUG 0

#ifndef YYENABLE_NLS
#define YYENABLE_NLS 0
#endif
#ifndef YYLTYPE_IS_TRIVIAL
#define YYLTYPE_IS_TRIVIAL 0
#endif

#if YYDEBUG
static int amd_fprintf(FILE *, char *, ...);
#undef YYFPRINTF
#define YYFPRINTF amd_fprintf
#endif


#line 166 "amd_parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "amd_parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_COMMENT = 3,                    /* COMMENT  */
  YYSYMBOL_SEPERATOR = 4,                  /* SEPERATOR  */
  YYSYMBOL_SPACE = 5,                      /* SPACE  */
  YYSYMBOL_HYPHEN = 6,                     /* HYPHEN  */
  YYSYMBOL_IS_EQUAL = 7,                   /* IS_EQUAL  */
  YYSYMBOL_CUT = 8,                        /* CUT  */
  YYSYMBOL_NOT_EQUAL = 9,                  /* NOT_EQUAL  */
  YYSYMBOL_COMMA = 10,                     /* COMMA  */
  YYSYMBOL_QUOTE = 11,                     /* QUOTE  */
  YYSYMBOL_OPTION_ASSIGN = 12,             /* OPTION_ASSIGN  */
  YYSYMBOL_LBRACKET = 13,                  /* LBRACKET  */
  YYSYMBOL_RBRACKET = 14,                  /* RBRACKET  */
  YYSYMBOL_NOT = 15,                       /* NOT  */
  YYSYMBOL_NILL = 16,                      /* NILL  */
  YYSYMBOL_MAP_OPTION = 17,                /* MAP_OPTION  */
  YYSYMBOL_MAP_TYPE = 18,                  /* MAP_TYPE  */
  YYSYMBOL_CACHE_OPTION = 19,              /* CACHE_OPTION  */
  YYSYMBOL_FS_TYPE = 20,                   /* FS_TYPE  */
  YYSYMBOL_FS_OPTION = 21,                 /* FS_OPTION  */
  YYSYMBOL_FS_OPT_VALUE = 22,              /* FS_OPT_VALUE  */
  YYSYMBOL_MNT_OPTION = 23,                /* MNT_OPTION  */
  YYSYMBOL_SELECTOR = 24,                  /* SELECTOR  */
  YYSYMBOL_SELECTOR_VALUE = 25,            /* SELECTOR_VALUE  */
  YYSYMBOL_SEL_ARG_VALUE = 26,             /* SEL_ARG_VALUE  */
  YYSYMBOL_OPTION = 27,                    /* OPTION  */
  YYSYMBOL_MACRO = 28,                     /* MACRO  */
  YYSYMBOL_OTHER = 29,                     /* OTHER  */
  YYSYMBOL_YYACCEPT = 30,                  /* $accept  */
  YYSYMBOL_file = 31,                      /* file  */
  YYSYMBOL_32_1 = 32,                      /* $@1  */
  YYSYMBOL_line = 33,                      /* line  */
  YYSYMBOL_location_selection_list = 34,   /* location_selection_list  */
  YYSYMBOL_location = 35,                  /* location  */
  YYSYMBOL_location_entry = 36,            /* location_entry  */
  YYSYMBOL_selector_or_option = 37,        /* selector_or_option  */
  YYSYMBOL_selection = 38,                 /* selection  */
  YYSYMBOL_option_assignment = 39,         /* option_assignment  */
  YYSYMBOL_options = 40                    /* options  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   61

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  38
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  58

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   284


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   130,   130,   130,   138,   139,   142,   149,   156,   166,
     169,   173,   179,   182,   185,   190,   193,   196,   203,   210,
     217,   224,   231,   238,   245,   252,   261,   266,   271,   318,
     334,   373,   402,   410,   418,   426,   438,   467,   471
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "COMMENT", "SEPERATOR",
  "SPACE", "HYPHEN", "IS_EQUAL", "CUT", "NOT_EQUAL", "COMMA", "QUOTE",
  "OPTION_ASSIGN", "LBRACKET", "RBRACKET", "NOT", "NILL", "MAP_OPTION",
  "MAP_TYPE", "CACHE_OPTION", "FS_TYPE", "FS_OPTION", "FS_OPT_VALUE",
  "MNT_OPTION", "SELECTOR", "SELECTOR_VALUE", "SEL_ARG_VALUE", "OPTION",
  "MACRO", "OTHER", "$accept", "file", "$@1", "line",
  "location_selection_list", "location", "location_entry",
  "selector_or_option", "selection", "option_assignment", "options", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-34)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -34,     5,     4,   -34,    14,   -16,     1,    12,    24,     7,
     -34,   -34,    27,   -34,    35,   -34,   -34,   -34,    35,    32,
      22,    25,    -5,    21,    23,    26,    -6,    14,    28,   -34,
     -34,   -34,   -34,   -34,    29,    39,   -34,   -34,   -34,    -7,
      45,   -34,   -34,    20,    40,    29,    31,   -34,     4,    33,
     -34,   -34,   -34,    41,   -34,    44,   -34,   -34
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     4,     1,    11,     0,     0,     0,     0,     0,
      17,     3,     5,     6,     9,    12,    15,    16,    10,     0,
      29,    31,    34,    19,    21,     0,     0,    14,     0,    27,
      35,    26,    28,    30,     0,    36,    32,    18,    20,     0,
       0,     7,    13,     0,     0,    38,     0,    22,     0,     0,
      24,    33,    37,     0,     8,     0,    23,    25
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -34,   -34,   -34,   -34,   -34,   -22,    49,    34,   -34,   -34,
     -33
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     2,    11,    12,    13,    14,    15,    16,    17,
      36
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
       4,    44,    40,    46,    41,     3,    34,    47,    19,     5,
       4,     6,    52,    20,    23,     7,    24,     8,     9,     5,
      25,     6,    35,    10,    21,     7,    54,     8,     9,     5,
      49,     6,    26,    10,    50,     7,    22,     8,     9,    27,
      29,    30,    31,    10,    32,    28,    37,    33,    38,    45,
      48,    51,    39,    18,    43,    56,    35,    53,    57,    55,
       0,    42
};

static const yytype_int8 yycheck[] =
{
       6,    34,     8,    10,    26,     0,    11,    14,    24,    15,
       6,    17,    45,    12,     7,    21,     9,    23,    24,    15,
      13,    17,    27,    29,    12,    21,    48,    23,    24,    15,
      10,    17,     5,    29,    14,    21,    12,    23,    24,     4,
      18,    19,    20,    29,    22,    13,    25,    22,    25,    10,
       5,    11,    26,     4,    26,    14,    27,    26,    14,    26,
      -1,    27
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    31,    32,     0,     6,    15,    17,    21,    23,    24,
      29,    33,    34,    35,    36,    37,    38,    39,    36,    24,
      12,    12,    12,     7,     9,    13,     5,     4,    13,    18,
      19,    20,    22,    22,    11,    27,    40,    25,    25,    26,
       8,    35,    37,    26,    40,    10,    10,    14,     5,    10,
      14,    11,    40,    26,    35,    26,    14,    14
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    30,    32,    31,    33,    33,    34,    34,    34,    35,
      35,    35,    36,    36,    36,    37,    37,    37,    38,    38,
      38,    38,    38,    38,    38,    38,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    40,    40,    40
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     0,     1,     1,     3,     5,     1,
       2,     1,     1,     3,     2,     1,     1,     1,     3,     2,
       3,     2,     4,     6,     5,     7,     3,     3,     3,     2,
       3,     2,     3,     5,     2,     3,     1,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 130 "amd_parse.y"
      {
#if YYDEBUG != 0
		amd_debug = YYDEBUG;
#endif
		memset(opts, 0, sizeof(opts));
	}
#line 1231 "amd_parse.tab.c"
    break;

  case 6: /* location_selection_list: location  */
#line 143 "amd_parse.y"
        {
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1242 "amd_parse.tab.c"
    break;

  case 7: /* location_selection_list: location_selection_list SPACE location  */
#line 150 "amd_parse.y"
        {
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1253 "amd_parse.tab.c"
    break;

  case 8: /* location_selection_list: location_selection_list SPACE CUT SPACE location  */
#line 157 "amd_parse.y"
        {
		entry.flags |= AMD_ENTRY_CUT;
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1265 "amd_parse.tab.c"
    break;

  case 9: /* location: location_entry  */
#line 167 "amd_parse.y"
        {
	}
#line 1272 "amd_parse.tab.c"
    break;

  case 10: /* location: HYPHEN location_entry  */
#line 170 "amd_parse.y"
        {
		entry.flags |= AMD_DEFAULTS_MERGE;
	}
#line 1280 "amd_parse.tab.c"
    break;

  case 11: /* location: HYPHEN  */
#line 174 "amd_parse.y"
        {
		entry.flags |= AMD_DEFAULTS_RESET;
	}
#line 1288 "amd_parse.tab.c"
    break;

  case 12: /* location_entry: selector_or_option  */
#line 180 "amd_parse.y"
        {
	}
#line 1295 "amd_parse.tab.c"
    break;

  case 13: /* location_entry: location_entry SEPERATOR selector_or_option  */
#line 183 "amd_parse.y"
        {
	}
#line 1302 "amd_parse.tab.c"
    break;

  case 14: /* location_entry: location_entry SEPERATOR  */
#line 186 "amd_parse.y"
        {
	}
#line 1309 "amd_parse.tab.c"
    break;

  case 15: /* selector_or_option: selection  */
#line 191 "amd_parse.y"
        {
	}
#line 1316 "amd_parse.tab.c"
    break;

  case 16: /* selector_or_option: option_assignment  */
#line 194 "amd_parse.y"
        {
	}
#line 1323 "amd_parse.tab.c"
    break;

  case 17: /* selector_or_option: OTHER  */
#line 197 "amd_parse.y"
        {
		amd_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 1332 "amd_parse.tab.c"
    break;

  case 18: /* selection: SELECTOR IS_EQUAL SELECTOR_VALUE  */
#line 204 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-2].strtype), (yyvsp[0].strtype), NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1343 "amd_parse.tab.c"
    break;

  case 19: /* selection: SELECTOR IS_EQUAL  */
#line 211 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-1].strtype), "", NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1354 "amd_parse.tab.c"
    break;

  case 20: /* selection: SELECTOR NOT_EQUAL SELECTOR_VALUE  */
#line 218 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-2].strtype), (yyvsp[0].strtype), NULL, SEL_COMP_NOTEQUAL)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1365 "amd_parse.tab.c"
    break;

  case 21: /* selection: SELECTOR NOT_EQUAL  */
#line 225 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-1].strtype), "", NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1376 "amd_parse.tab.c"
    break;

  case 22: /* selection: SELECTOR LBRACKET SEL_ARG_VALUE RBRACKET  */
#line 232 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-3].strtype), (yyvsp[-1].strtype), NULL, SEL_COMP_NONE)) {
			amd_notify((yyvsp[-3].strtype));
			YYABORT;
		}
	}
#line 1387 "amd_parse.tab.c"
    break;

  case 23: /* selection: SELECTOR LBRACKET SEL_ARG_VALUE COMMA SEL_ARG_VALUE RBRACKET  */
#line 239 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-5].strtype), (yyvsp[-3].strtype), (yyvsp[-1].strtype), SEL_COMP_NONE)) {
			amd_notify((yyvsp[-5].strtype));
			YYABORT;
		}
	}
#line 1398 "amd_parse.tab.c"
    break;

  case 24: /* selection: NOT SELECTOR LBRACKET SEL_ARG_VALUE RBRACKET  */
#line 246 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-3].strtype), (yyvsp[-1].strtype), NULL, SEL_COMP_NOT)) {
			amd_notify((yyvsp[-3].strtype));
			YYABORT;
		}
	}
#line 1409 "amd_parse.tab.c"
    break;

  case 25: /* selection: NOT SELECTOR LBRACKET SEL_ARG_VALUE COMMA SEL_ARG_VALUE RBRACKET  */
#line 253 "amd_parse.y"
        {
		if (!make_selector((yyvsp[-5].strtype), (yyvsp[-3].strtype), (yyvsp[-1].strtype), SEL_COMP_NOT)) {
			amd_notify((yyvsp[-5].strtype));
			YYABORT;
		}
	}
#line 1420 "amd_parse.tab.c"
    break;

  case 26: /* option_assignment: MAP_OPTION OPTION_ASSIGN FS_TYPE  */
#line 262 "amd_parse.y"
        {
		if (!match_map_option_fs_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
			YYABORT;
	}
#line 1429 "amd_parse.tab.c"
    break;

  case 27: /* option_assignment: MAP_OPTION OPTION_ASSIGN MAP_TYPE  */
#line 267 "amd_parse.y"
        {
		if (!match_map_option_map_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
			YYABORT;
	}
#line 1438 "amd_parse.tab.c"
    break;

  case 28: /* option_assignment: MAP_OPTION OPTION_ASSIGN FS_OPT_VALUE  */
#line 272 "amd_parse.y"
        {
		/* Quoted value for type, maptype or cache assign */
		if (!strcmp((yyvsp[-2].strtype), "type")) {
			if (!match_map_option_fs_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
				YYABORT;
		} else if (!strcmp((yyvsp[-2].strtype), "maptype")) {
			if (!match_map_option_map_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
				YYABORT;
		} else if (!strcmp((yyvsp[-2].strtype), "cache")) {
			if (!match_map_option_cache_option((yyvsp[0].strtype)))
				YYABORT;
		} else {
			char *fs_opt_val;

			fs_opt_val = amd_strdup((yyvsp[0].strtype));
			if (!fs_opt_val) {
				amd_notify((yyvsp[0].strtype));
				YYABORT;
			}

			if (!strcmp((yyvsp[-2].strtype), "fs"))
				amd_set_value(&entry.fs, fs_opt_val);
			else if (!strcmp((yyvsp[-2].strtype), "sublink")) {
				amd_set_value(&entry.sublink, fs_opt_val);
			} else if (!strcmp((yyvsp[-2].strtype), "pref")) {
				if (strcmp(fs_opt_val, "null"))
					amd_set_value(&entry.pref, fs_opt_val);
				else {
					char *empty;

					empty = amd_strdup("");
					if (!empty) {
						amd_notify((yyvsp[0].strtype));
						free(fs_opt_val);
						YYABORT;
					}
					amd_set_value(&entry.pref, empty);
					free(fs_opt_val);
				}
			} else {
				amd_notify((yyvsp[-2].strtype));
				free(fs_opt_val);
				YYABORT;
			}
		}
	}
#line 1489 "amd_parse.tab.c"
    break;

  case 29: /* option_assignment: MAP_OPTION OPTION_ASSIGN  */
#line 319 "amd_parse.y"
        {
		if (!strcmp((yyvsp[-1].strtype), "fs")) {
			char *empty;

			empty = amd_strdup("");
			if (!empty) {
				amd_notify((yyvsp[-1].strtype));
				YYABORT;
			}
			amd_set_value(&entry.fs, empty);
		} else {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1509 "amd_parse.tab.c"
    break;

  case 30: /* option_assignment: FS_OPTION OPTION_ASSIGN FS_OPT_VALUE  */
#line 335 "amd_parse.y"
        {
		char *fs_opt_val;

		fs_opt_val = amd_strdup((yyvsp[0].strtype));
		if (!fs_opt_val) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}

		if (!strcmp((yyvsp[-2].strtype), "rhost"))
			amd_set_value(&entry.rhost, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "rfs"))
			amd_set_value(&entry.rfs, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "dev"))
			amd_set_value(&entry.dev, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "mount"))
			amd_set_value(&entry.mount, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "unmount") ||
			 !strcmp((yyvsp[-2].strtype), "umount")) {
			if (entry.umount) {
				sprintf(msg_buf,
				    "unmount or umount may only be used once");
				amd_info(msg_buf);
				free(fs_opt_val);
				YYABORT;
			}
			entry.umount = fs_opt_val;
		} else if (!strcmp((yyvsp[-2].strtype), "delay") ||
			   !strcmp((yyvsp[-2].strtype), "cachedir")) {
			sprintf(msg_buf, "option %s is not used by autofs", (yyvsp[-2].strtype));
			amd_info(msg_buf);
			free(fs_opt_val);
		} else {
			amd_notify((yyvsp[-2].strtype));
			free(fs_opt_val);
			YYABORT;
		}
	}
#line 1552 "amd_parse.tab.c"
    break;

  case 31: /* option_assignment: FS_OPTION OPTION_ASSIGN  */
#line 374 "amd_parse.y"
        {
		char *empty;

		empty = amd_strdup("");
		if (!empty) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}

		if (!strcmp((yyvsp[-1].strtype), "rhost"))
			amd_set_value(&entry.rhost, empty);
		else if (!strcmp((yyvsp[-1].strtype), "rfs"))
			amd_set_value(&entry.rfs, empty);
		else if (!strcmp((yyvsp[-1].strtype), "dev"))
			amd_set_value(&entry.dev, empty);
		else if (!strcmp((yyvsp[-1].strtype), "mount")) {
			amd_set_value(&entry.mount, NULL);
			free(empty);
		} else if (!strcmp((yyvsp[-1].strtype), "umount") ||
			   !strcmp((yyvsp[-1].strtype), "unmount")) {
			amd_set_value(&entry.umount, NULL);
			free(empty);
		} else {
			amd_notify((yyvsp[-1].strtype));
			free(empty);
			YYABORT;
		}
	}
#line 1585 "amd_parse.tab.c"
    break;

  case 32: /* option_assignment: MNT_OPTION OPTION_ASSIGN options  */
#line 403 "amd_parse.y"
        {
		if (!match_mnt_option_options((yyvsp[-2].strtype), opts)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
		memset(opts, 0, sizeof(opts));
	}
#line 1597 "amd_parse.tab.c"
    break;

  case 33: /* option_assignment: MNT_OPTION OPTION_ASSIGN QUOTE options QUOTE  */
#line 411 "amd_parse.y"
        {
		if (!match_mnt_option_options((yyvsp[-4].strtype), opts)) {
			amd_notify((yyvsp[-4].strtype));
			YYABORT;
		}
		memset(opts, 0, sizeof(opts));
	}
#line 1609 "amd_parse.tab.c"
    break;

  case 34: /* option_assignment: MNT_OPTION OPTION_ASSIGN  */
#line 419 "amd_parse.y"
        {
		memset(opts, 0, sizeof(opts));
		if (!match_mnt_option_options((yyvsp[-1].strtype), "")) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1621 "amd_parse.tab.c"
    break;

  case 35: /* option_assignment: MAP_OPTION OPTION_ASSIGN CACHE_OPTION  */
#line 427 "amd_parse.y"
        {
		if (!strcmp((yyvsp[-2].strtype), "cache")) {
			if (!match_map_option_cache_option((yyvsp[0].strtype)))
				YYABORT;
		} else {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1635 "amd_parse.tab.c"
    break;

  case 36: /* options: OPTION  */
#line 439 "amd_parse.y"
        {
		if (!strcmp((yyvsp[0].strtype), "fullybrowsable") ||
		    !strcmp((yyvsp[0].strtype), "nounmount")) {
			sprintf(msg_buf, "option %s is not currently "
					 "implemented, ignored", (yyvsp[0].strtype));
			amd_info(msg_buf);
		} else if (!strncmp((yyvsp[0].strtype), "ping=", 5) ||
			   !strncmp((yyvsp[0].strtype), "retry=", 6) ||
			   !strcmp((yyvsp[0].strtype), "public") ||
			   !strcmp((yyvsp[0].strtype), "softlookup") ||
			   !strcmp((yyvsp[0].strtype), "xlatecookie")) {
			sprintf(msg_buf, "option %s is not used by "
					 "autofs, ignored", (yyvsp[0].strtype));
			amd_info(msg_buf);
		} else if (!strncmp((yyvsp[0].strtype), "utimeout=", 9)) {
			if (entry.flags & AMD_MOUNT_TYPE_AUTO) {
				char *opt = (yyvsp[0].strtype);
				prepend_opt(opts, ++opt);
			} else {
				sprintf(msg_buf, "umount timeout can't be "
						 "used for other than type "
						 "\"auto\" with autofs, "
						 "ignored");
				amd_info(msg_buf);
			}
		} else
			prepend_opt(opts, (yyvsp[0].strtype));
	}
#line 1668 "amd_parse.tab.c"
    break;

  case 37: /* options: OPTION COMMA options  */
#line 468 "amd_parse.y"
        {
		prepend_opt(opts, (yyvsp[-2].strtype));
	}
#line 1676 "amd_parse.tab.c"
    break;

  case 38: /* options: OPTION COMMA  */
#line 472 "amd_parse.y"
        {
		prepend_opt(opts, (yyvsp[-1].strtype));
	}
#line 1684 "amd_parse.tab.c"
    break;


#line 1688 "amd_parse.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 477 "amd_parse.y"


static int match_map_option_fs_type(char *map_option, char *type)
{
	char *fs_type;

	fs_type = amd_strdup(type);
	if (!fs_type) {
		amd_notify(type);
		return 0;
	}

	if (!strcmp(fs_type, "auto"))
		entry.flags |= AMD_MOUNT_TYPE_AUTO;
	else if (!strcmp(fs_type, "nfs") ||
		 !strcmp(fs_type, "nfs4"))
		entry.flags |= AMD_MOUNT_TYPE_NFS;
	else if (!strcmp(fs_type, "nfsl"))
		entry.flags |= AMD_MOUNT_TYPE_NFSL;
	else if (!strcmp(fs_type, "link"))
		entry.flags |= AMD_MOUNT_TYPE_LINK;
	else if (!strcmp(fs_type, "linkx"))
		entry.flags |= AMD_MOUNT_TYPE_LINKX;
	else if (!strcmp(fs_type, "host"))
		entry.flags |= AMD_MOUNT_TYPE_HOST;
	else if (!strcmp(fs_type, "lofs"))
		entry.flags |= AMD_MOUNT_TYPE_LOFS;
	else if (!strcmp(fs_type, "xfs"))
		entry.flags |= AMD_MOUNT_TYPE_XFS;
	else if (!strcmp(fs_type, "ext2") ||
		   !strcmp(fs_type, "ext3") ||
		   !strcmp(fs_type, "ext4"))
		entry.flags |= AMD_MOUNT_TYPE_EXT;
	else if (!strcmp(fs_type, "program"))
		entry.flags |= AMD_MOUNT_TYPE_PROGRAM;
	else if (!strcmp(fs_type, "ufs")) {
		entry.flags |= AMD_MOUNT_TYPE_UFS;
		entry.type = conf_amd_get_linux_ufs_mount_type();
		if (!entry.type) {
			amd_msg("memory allocation error");
			amd_notify(type);
			free(fs_type);
			return 0;
		}
		free(fs_type);
		fs_type = NULL;
	} else if (!strcmp(fs_type, "cdfs")) {
		entry.flags |= AMD_MOUNT_TYPE_CDFS;
		entry.type = amd_strdup("iso9660");
		if (!entry.type) {
			amd_msg("memory allocation error");
			amd_notify(map_option);
			free(fs_type);
			return 0;
		}
		free(fs_type);
		fs_type = NULL;
	} else if (!strcmp(fs_type, "jfs") ||
		   !strcmp(fs_type, "nfsx") ||
		   !strcmp(fs_type, "lustre") ||
		   !strcmp(fs_type, "direct")) {
		sprintf(msg_buf, "file system type %s is "
				 "not yet implemented", fs_type);
		amd_msg(msg_buf);
		free(fs_type);
		return 0;
	} else if (!strcmp(fs_type, "cachefs")) {
		sprintf(msg_buf, "file system %s is not "
				 "supported by autofs, ignored",
				 fs_type);
		amd_msg(msg_buf);
		free(fs_type);
		fs_type = NULL;
	} else {
		amd_notify(fs_type);
		free(fs_type);
		return 0;
	}

	if (fs_type)
		amd_set_value(&entry.type, fs_type);

	return 1;
}

static int match_map_option_map_type(char *map_option, char *type)
{
	char *map_type;

	map_type = amd_strdup(type);
	if (!map_type) {
		amd_notify(type);
		return 0;
	}

	if (!strcmp(map_type, "file") ||
	    !strcmp(map_type, "nis") ||
	    !strcmp(map_type, "nisplus") ||
	    !strcmp(map_type, "ldap") ||
	    !strcmp(map_type, "hesiod")) {
#ifndef WITH_HESIOD
		if (!strcmp(map_type, "hesiod")) {
			amd_msg("hesiod support not built in");
			free(map_type);
			return 0;
		}
#endif
		amd_set_value(&entry.map_type, map_type);
	} else if (!strcmp(map_type, "exec")) {
		/* autofs uses "program" for "exec" map type */
		char * tmp;

		tmp = amd_strdup("program");
		if (!tmp) {
			amd_notify(type);
			free(map_type);
			return 0;
		}
		amd_set_value(&entry.map_type, tmp);
		free(map_type);
	} else if (!strcmp(map_type, "passwd")) {
		sprintf(msg_buf, "map type %s is "
				 "not yet implemented", map_type);
		amd_msg(msg_buf);
		free(map_type);
		return 0;
	} else if (!strcmp(map_type, "ndbm") ||
		   !strcmp(map_type, "union")) {
		sprintf(msg_buf, "map type %s is not "
				 "supported by autofs", map_type);
		amd_msg(msg_buf);
		free(map_type);
		return 0;
	} else {
		amd_notify(type);
		free(map_type);
		return 0;
	}

	return 1;
}

static int match_map_option_cache_option(char *type)
{
	char *cache_opt;

	cache_opt = amd_strdup(type);
	if (!cache_opt) {
		amd_notify(type);
		return 0;
	}

	if (strncmp(cache_opt, "inc", 3))
		entry.cache_opts = AMD_CACHE_OPTION_INC;
	else if (strncmp(cache_opt, "all", 3))
		entry.cache_opts = AMD_CACHE_OPTION_ALL;
	else if (strncmp(cache_opt, "re", 2))
		entry.cache_opts = AMD_CACHE_OPTION_REGEXP;
	if (strstr(cache_opt, "sync"))
		entry.cache_opts |= AMD_CACHE_OPTION_SYNC;
	free(cache_opt);

	return 1;
}

static int match_mnt_option_options(char *mnt_option, char *options)
{
	char *tmp;

	if (!strcmp(mnt_option, "opts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.opts, tmp);
	} else if (!strcmp(mnt_option, "addopts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.addopts, tmp);
	} else if (!strcmp(mnt_option, "remopts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.remopts, tmp);
	} else
		return 0;

	return 1;
}

static void prepend_opt(char *dest, char *opt)
{
	char new[MAX_OPTS_LEN];
	strcpy(new, opt);
	if (*dest != '\0') {
		strcat(new, ",");
		strcat(new, dest);
	}
	memmove(dest, new, strlen(new));
}

#if YYDEBUG
static int amd_fprintf(FILE *f, char *msg, ...)
{
	va_list ap;
	va_start(ap, msg);
	vsyslog(LOG_DEBUG, msg, ap);
	va_end(ap);
	return 1;
}
#endif

static char *amd_strdup(char *str)
{
	unsigned int quoted, len;
	char *tmp;

	len = strlen(str);
	quoted = 0;

	if (*str == '"') {
		quoted = 1;
		len -= 2;
	}

	tmp = strdup(str + quoted);
	if (!tmp) {
		amd_msg("memory allocation error");
		return NULL;
	} else {
		unsigned int squote;
		char *ptr;

		if (quoted) {
			if (tmp[len] != '"') {
				sprintf(msg_buf,
					"unmatched double quote near: %s", str);
				amd_info(msg_buf);
				free(tmp);
				return NULL;
			}
			tmp[len] = 0;
		}

		/* Check for matching single quotes */
		if (!strchr(tmp, 39))
			goto done;

		ptr = tmp;
		squote = 0;
		while (*ptr) {
			if (*ptr == 39)
				squote = !squote;
			ptr++;
		}
		if (squote) {
			sprintf(msg_buf,
				"unmatched single quote near: %s", str);
			amd_info(msg_buf);
			free(tmp);
			return NULL;
		}
	}
done:
	return tmp;
}

static void amd_set_value(char **field, char *value)
{
	if (*field)
		free(*field);
	*field = value;
}

static int amd_error(const char *s)
{
	if (strcmp(s, "syntax"))
		logmsg("syntax error in location near [ %s ]\n", amd_text);
	else
		logmsg("%s while parsing location.\n", s);
	return 0;
}

static int amd_notify(const char *s)
{
	logmsg("syntax error in location near [ %s ]\n", s);
	return(0);
}

static int amd_info(const char *s)
{
	info(pap->logopt, "%s\n", s);
	return 0;
}

static int amd_msg(const char *s)
{
	logmsg("%s\n", s);
	return 0;
}

static void local_init_vars(void)
{
	memset(&entry, 0, sizeof(entry));
	entry.cache_opts = AMD_CACHE_OPTION_NONE;
	memset(opts, 0, sizeof(opts));
}

static void local_free_vars(void)
{
	clear_amd_entry(&entry);
	return;
}

static void add_selector(struct selector *selector)
{
	struct selector *s = entry.selector;

	if (!s) {
		entry.selector = selector;
		return;
	}

	while (s->next)
		s = s->next;

	selector->next = s;
	entry.selector = selector;

	return;
}

static int make_selector(char *name,
			 char *value1, char *value2,
			 unsigned int compare)
{
	struct selector *s;
	char *tmp;

	if (!sel_lookup(name))
		return 0;

	s = get_selector(name);
	if (!s)
		return 0;

	if (s->sel->flags & SEL_FLAG_MACRO) {
		tmp = amd_strdup(value1);
		if (!tmp)
			goto error;
		s->comp.value = tmp;
	} else if (s->sel->flags & SEL_FLAG_FUNC1) {
		if (!value1)
			tmp = NULL;
		else {
			tmp = amd_strdup(value1);
			if (!tmp)
				goto error;
		}
		s->func.arg1 = tmp;
	} else if (s->sel->flags & SEL_FLAG_FUNC2) {
		tmp = amd_strdup(value1);
		if (!tmp)
			goto error;
		s->func.arg1 = tmp;
		if (value2) {
			tmp = amd_strdup(value2);
			if (tmp)
				s->func.arg2 = tmp;
		}
	}
	s->compare = compare;

	add_selector(s);

	return 1;
error:
	free_selector(s);
	return 0;
}

void amd_init_scan(void)
{
}

static void parse_mutex_lock(void)
{
	int status = pthread_mutex_lock(&parse_mutex);
	if (status)
		fatal(status);
	return;
}

static void parse_mutex_unlock(void *arg)
{
	int status = pthread_mutex_unlock(&parse_mutex);
	if (status)
		fatal(status);
	return;
}

static int add_location(void)
{
	struct amd_entry *new;

	new = new_amd_entry(psv);
	if (!new)
		return 0;

	if (entry.path) {
		free(new->path);
		new->path = entry.path;
	}
	new->flags = entry.flags;
	new->type = entry.type;
	new->map_type = entry.map_type;
	new->pref = entry.pref;
	new->fs = entry.fs;
	new->rhost = entry.rhost;
	new->rfs = entry.rfs;
	new->dev = entry.dev;
	new->opts = entry.opts;
	new->addopts = entry.addopts;
	new->remopts = entry.remopts;
	new->sublink = entry.sublink;
	new->mount = entry.mount;
	new->umount = entry.umount;
	new->selector = entry.selector;
	list_add_tail(&new->list, entries);
	memset(&entry, 0, sizeof(struct amd_entry));

	return 1;
}

int amd_parse_list(struct autofs_point *ap,
		   const char *buffer, struct list_head *list,
		   struct substvar **sv)
{
	char *buf;
	size_t len;
	int ret;

	len = strlen(buffer) + 2;
	buf = malloc(len);
	if (!buf)
		return 0;
	strcpy(buf, buffer);

	parse_mutex_lock();
	pthread_cleanup_push(parse_mutex_unlock, NULL);

	pap = ap;
	psv = *sv;
	entries = list;
	amd_set_scan_buffer(buf);

	local_init_vars();
	ret = amd_parse();
	local_free_vars();
	*sv = psv;

	pthread_cleanup_pop(1);
	free(buf);

	return ret;
}
